% Set property in the specified object.
%
%   Call as:
%      a = set(a), or
%      a = set(a,prop_name,val)
%   where
%      a         - object
%      prop_name - property name
%                  To obtain settable property names, use set(a).
%      val       - value to be assigned to the property.
%
%   The first form may be used to obtain a list of settable properties;
%   the second form may be used to set a particular property, and the
%   modified object is returned (do not forget to assign it!).
%
function retval = set(self,varargin)
    if (nargin == 1)
        retval = {{{'eqnums'}, {'equation numbers, array [d,1]'}};
            {{'vec'}, {'data matrix, array [d,1]'}}};
        return;
    end
    prop_name=varargin{1};
    val=varargin{2};
    switch prop_name
        case 'vec'
            self.vec = val;
        case 'eqnums'
            self.eqnums = val;
        otherwise
            error(['Unknown property ''' prop_name '''!'])
    end
    retval=self; % return self
end