% Get property from the specified object and return the value.
%   Call as:
%      get(obj), or
%      get(obj,prop_name)
%   where
%      obj       - object
%      prop_name - property name
%
%   The first form returns the list of property names as a string,
%   the second form returns the value of the named property.
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'mater'}, {'material object'}};
            {{'gcells'}, {'geometric cells, array of descendants of the gcell class'}};
            {{'integration_rule'}, {'integration rule, object'}};
            {{'Rm'}, {'transformation matrix, local material directions in columns'}};
            {{'matstates'}, {'material states for each gcell and each integration point'}}};
        return;
    else
        %  disp('looking for feblock.mater');
        prop_name=varargin{1};
        %  self.mater
        switch prop_name
            case 'mater'
                val = self.mater;
            case 'gcells'
                val = self.gcells;
            case 'integration_rule'
                val = self.integration_rule;
            case 'Rm'
                val = self.Rm;
            case 'feblock'
                val = self;
            otherwise
                error(['Unknown property name ''' prop_name '''!']);
        end
    end
end
